//uj@cs.mipt.ru

using System;
using System.Collections.Generic;
using System.Text;

using jade.core;
using jade.lang.acl;
using jade.core.behaviours;

namespace MASTask1
{
    //[c] Gamer-class:
    class BoneGamer : Agent
    {
        public override void setup()
        {
            addBehaviour(new Activity(this));
        }
    }
    //[c] Main gamer activity class:
    class Activity : Behaviour
    {
        private bool finilize = false;
        private bool firstTime = true;

        public Activity(Agent agent) : base(agent)
        {
            say("arrived");
            say("Participation request has sent"); 

            firstTime = false;
            ACLMessage participateMessage = new ACLMessage(ACLMessage.INFORM);
            participateMessage.setContent("Participation request");
            participateMessage.addReceiver(new AID("BoneServer", AID.ISLOCALNAME));
            myAgent.send(participateMessage);

        }
        public override void action()
        {
            ACLMessage response = myAgent.receive();
            if (response != null)
            {


                ACLMessage nextTurn = new ACLMessage(ACLMessage.INFORM);
                Random dice = new Random();
                int points;
                points = 0;
                switch (response.getContent())
                {
                    case "Loser":
                        {
                            say("I'm a loser. Terminating.");
                            setFinalize();
                            break;
                        }
                    case "Winner":
                        {
                            say("I'm the winner. Terminating.");
                            setFinalize();
                            break;
                        }
                    case "Approved":
                        {
                            nextTurn.setContent("Turn");
                            
                            nextTurn.addReceiver(new AID("BoneServer", AID.ISLOCALNAME));
                            myAgent.send(nextTurn);
                            break;
                        
                        }
                    case "Next":
                        {
                            nextTurn.setContent("Turn");
                            say("I've already thown the dices");
                            nextTurn.addReceiver(new AID("BoneServer", AID.ISLOCALNAME));
                            myAgent.send(nextTurn);
                            break;
                        }

                }
            }
            else
            {
                block();
            }
            

        }
        public override bool done()
        {
            return finilize;
        }
        private void setFinalize()
        {
            finilize = true;
        }
        public void say(string message)
        {
            Console.WriteLine(myAgent.getLocalName() + ": <" + message + ">\n");
        }
    }
}
