
using System;
using System.Collections.Generic;
using System.Text;

using jade.core;
using jade.core.behaviours;
using jade.lang.acl;


namespace MASTask1
{
   
    //[c] Server-class:
    class BoneServer : Agent
    {
        
        public override void setup()
        {
            addBehaviour(new Initialization(this));
        }
    }
    //[c] Server initial behaviour:
    class Initialization : Behaviour
    {
        private bool finilize = false;
        private bool ready = false;
        private int swap;
        private AID firstConnection = null, secondConnection = null;
        private int firstPoints, secondPoints;
        private bool gflag = true;

        public Initialization(Agent agent) : base(agent)
        {
            say("Server's reporting");
            say("Waiting for gamers...");
            swap = 1;
        }
        public override void action()
        {
            
            ACLMessage response = myAgent.receive();
            if (response != null)
            {
                int flag = 0;
                if (ready == false)
                {

                    {
                        if (response.getContent() == "Participation request")
                        {
                            say("I've got authorization request from " + response.getSender().getLocalName());
                            if (firstConnection == null)
                            {
                                firstConnection = response.getSender();
                                ACLMessage approve = new ACLMessage(ACLMessage.INFORM);
                                approve.setContent("Approved");
                                say(response.getSender().getLocalName() + "'s participation is approved");
                                approve.addReceiver(new AID(response.getSender().getLocalName(), AID.ISLOCALNAME));
                            //    myAgent.send(approve);
                            }
                            else
                            {
                                if (secondConnection == null)
                                {
                                    secondConnection = response.getSender();
                                    ACLMessage approve = new ACLMessage(ACLMessage.INFORM);
                                    approve.setContent("Approved");
                                    say(response.getSender().getLocalName() + "'s participation is approved");
                                    approve.addReceiver(new AID(response.getSender().getLocalName(), AID.ISLOCALNAME));
                                    myAgent.send(approve);
                                    setReady();
                                    flag = 1;
                                   
                                }
                            }
                        }


                    }
                }

                if (ready == true && flag == 0)
                {
                    gflag = true;

                    for(;;)
                    {
                    
                        if (swap == 1)
                        {
                            ACLMessage turn1 = new ACLMessage(ACLMessage.INFORM);
                            turn1.setContent("Next");
                            turn1.addReceiver(firstConnection);
                            myAgent.send(turn1);

                            swap = 2;
                            return;
                        }
                        if (swap == 2)
                        {
                            Random nextvalue = new Random();
                            firstPoints = nextvalue.Next(1, 6) + nextvalue.Next(1, 6);
                            say(firstConnection.getLocalName() + " have " + firstPoints.ToString());
                            ACLMessage turn2 = new ACLMessage(ACLMessage.INFORM);
                            turn2.setContent("Next");
                            turn2.addReceiver(secondConnection);
                            myAgent.send(turn2);
                            
                            swap = 3;
                            return;
                        }
                        if (swap == 3)
                        {

                            Random nextvalue = new Random();
                            secondPoints = nextvalue.Next(1, 6) + nextvalue.Next(1, 6);
                            say(secondConnection.getLocalName() + " have " + secondPoints.ToString());
                            if (firstPoints == secondPoints)
                            {
                                swap = 1;
                                say("Draw. Next attempt.");
                                continue;

                            }
                            swap = 1;
                            if (firstPoints < secondPoints)
                            {
                                ACLMessage win = new ACLMessage(ACLMessage.INFORM);
                                ACLMessage lose = new ACLMessage(ACLMessage.INFORM);
                                win.setContent("Winner");
                                lose.setContent("Loser");
                                win.addReceiver(secondConnection);
                                lose.addReceiver(firstConnection);
                                myAgent.send(win);
                                myAgent.send(lose);
                                finilize = true;
                                gflag = false;
                            }
                            if (firstPoints > secondPoints)
                            {
                                ACLMessage win = new ACLMessage(ACLMessage.INFORM);
                                ACLMessage lose = new ACLMessage(ACLMessage.INFORM);
                                win.setContent("Winner");
                                lose.setContent("Loser");
                                win.addReceiver(firstConnection);
                                lose.addReceiver(secondConnection);
                                myAgent.send(win);
                                myAgent.send(lose);
                                finilize = true;
                                gflag = false;
                            }
                        }
                        if (gflag == false)
                        {
                            break;
                        }
                    }

                }

            }
            else
            {
                block();
            }
           
            
        }
        public override bool done()
        {
            return finilize;
        }
        public void setReady()
        {
            ready = true;
        }
        public void say(string message)
        {
            Console.WriteLine("SERVER: <" + message + ">\n");
        }
    }
    class Playing : Behaviour
    {
        private bool finilize = false;
        private int swap;

        public Playing(Agent agent) : base(agent)
        {
            swap = 1;
        }
        public override void action()
        {
            if (finilize == true)
                block();

        
            
        }
        public override bool done()
        {
            return finilize;
        }
        
    }
}
