﻿using System;
using System.Collections.Generic;
using System.Text;

using jade.proto;
using jade.core;
using jade.core.behaviours;

using jade.lang.acl;
using java.lang;

using jade.domain;
using jade.domain.FIPAAgentManagement;
using jade.domain.DFGUIManagement;

using java.util;

namespace Buyer
{
    public class Buyer : Agent
    {
        private AID[] sellers;
        java.util.Random random = new java.util.Random();
        
        public override void setup()
        {
            say(" 's here.");

   
            DFAgentDescription dfd = new DFAgentDescription();
            ServiceDescription sd = new ServiceDescription();
            sd.setType("seller");
            dfd.addServices(sd);
            DFAgentDescription[] searchResult = null;
            try
            {
                searchResult = DFService.search(this, dfd);
            }
            catch (FIPAException e)
            {
                e.printStackTrace();
            }
            sellers = new AID[searchResult.Length];
            say(" i've found: ");
            for (int i = 0; i < sellers.Length; i++)
            {
                sellers[i] = searchResult[i].getName();
                say("\t\t" + sellers[i].getLocalName());
            }

            ACLMessage me = new ACLMessage();
            me.setProtocol("MY_PRTCL");
            addBehaviour(new DoActions(this, sellers));
        }

        private void say(string message)
        {
            System.Console.WriteLine("[" + getLocalName() + "]: " + message);
        }
    }
    class Book
    {
        private int price = 0;
        private bool exist = false;
      
        public Book( int priceP )
        {
            price = priceP;
            exist = true;
        }
        public int getPrice()
        {
            return price;
        }
        public bool isExists()
        {
            return exist;
        }
        public void buy()
        {
            exist = false;
        }
    }
    class DoActions : SequentialBehaviour
    {
        private int attempts = 1;
        public DoActions(Agent a, AID[] sellers)
            : base(a)
        {
            ACLMessage me = new ACLMessage();
            java.util.Random rnd = new java.util.Random();
            int count = 3 + rnd.nextInt(3);
            Book[] books = new Book[count];
            java.util.Random random = new java.util.Random();
            for (int i = 0; i < count; i++)
            {
                
                books[i] = new Book(20 + random.nextInt(20));
            }
            me.setProtocol("MY_PRTCL");
            for (int j = 0; j < attempts; j++)
            {
                for (int i = 0; i < count; i++)
                {
                    if (books[i].isExists())
                        addSubBehaviour(new PerformActions(myAgent, me, sellers, books[i]));
                }
            }
        }
    }
    class PerformActions : ContractNetInitiator
    {
        private AID[] sellers;
        private int state = 0;
        private Book book = null;
        public PerformActions(Agent a, ACLMessage cfp, AID[] sellersP, Book bookP) : base(a, cfp)
        {
            sellers = sellersP;
            book = bookP;
        }
        public override Vector prepareCfps(ACLMessage cfp)
        {
            switch (state)
            {
                case 0:
                    {
                        Vector cfps = new Vector(sellers.Length);
                        ACLMessage request = new ACLMessage();
                        request.setProtocol("MY_PRTCL");
                        request.setContent("empty");
                        request.setConversationId(sellers[0].getLocalName());

                        for (int i = 0; i < sellers.Length; i++)
                        {
                            request.addReceiver(sellers[i]);
                        }
                        cfps.add(request);
                        return cfps;
                    }
                default:
                    {
                        return null;
                    }

            }
        }

        public override void handleAllResponses(Vector responses, Vector cfps)
        {
            int bestprice = 10000;
            AID seller = null;
            for (int i = 0; i < responses.size(); i++)
            {
                ACLMessage msg = (ACLMessage)responses.elementAt(i);
                int price = Integer.parseInt(msg.getContent());
                if (price < bestprice)
                {
                    bestprice = price;
                    seller = msg.getSender();
                }
            }
            say("has chosen price " + bestprice + "$ from " + seller.getLocalName());
            if (book.getPrice() >= bestprice)
            {
                say("\"+++\"I have " + book.getPrice() + "$ and i can afford it.");
                book.buy();
            }
            else
            {
                say("\"---\"I have only " + book.getPrice() + "$ and i can't buy it.");                   
            }
        }
        private void say(string message)            
        {
            System.Console.WriteLine("[" + myAgent.getLocalName() + "]: " + message);
        }
    }
}