using jade.core;
using jade.domain.DFGUIManagement;
using jade.domain;
using jade.domain.FIPAAgentManagement;

using jade.lang.acl;
using jade.proto;

namespace Buyer
{
    public class Seller : Agent
    {
        java.util.Random random = new java.util.Random();

        public override void setup()
        {
            say("Seller " + getAID().getLocalName() + " is ready.");
            DFAgentDescription dfd = new DFAgentDescription();
            dfd.setName(getAID());
            ServiceDescription sd = new ServiceDescription();
            sd.setType("seller");
            sd.setName(getLocalName());
            dfd.addServices(sd);
            try
            {
                DFService.register(this, dfd);
            }
            catch (FIPAException fe)
            {
                fe.printStackTrace();
            }
            say(" has registered.");
            MessageTemplate mt = ContractNetResponder.createMessageTemplate("MY_PRTCL");
           
            addBehaviour(new SellerActions(this, mt));
        }
        

        public override void takeDown()
        {
            try
            {
                DFService.deregister(this);
            }
            catch (FIPAException e)
            {
                say("error was occurred");
                e.printStackTrace();
            }
        }
       

        private void say(string message)
        {
            System.Console.WriteLine("[" + getLocalName() + "] " + message);
        }
    }
    class SellerActions : ContractNetResponder
    {
        public SellerActions(Agent a, MessageTemplate mt)
            : base(a, mt)
        {
            
        }
        public override ACLMessage prepareResponse(ACLMessage request)
        {
            java.util.Random random = new java.util.Random();
            int myprice = random.nextInt(20) + 20;

            say("got request from " + request.getSender().getLocalName());
            say("my price is " + myprice + "$");
            ACLMessage reply = request.createReply();
            reply.setContent(myprice.ToString());
            return reply;
        }
        
        private void say(string message)
        {
            System.Console.WriteLine("[" + myAgent.getLocalName() + "] " + message);
        }
 
    }
 
}